<template>
  <div>
    <div id="TOSAndPP" class="card bg-light w-100">
      <div class="card-body">
        <h5 class="card-title">{{ $t("tosppTitle") }}</h5>
        <p class="card-text">
          {{ $t("tosBodyStart")
          }}<a
            href="https://git.rwth-aachen.de/coscine/docs/public/terms/-/blob/master/TermsOfUse.md"
            >Link</a
          >{{ $t("tosBodyEnd") }}
        </p>
        <b-form-checkbox id="checkboxTOS" v-model="checkedTOS">{{
          $t("tosBodyCheckBox")
        }}</b-form-checkbox>
        <p class="card-text">
          {{ $t("ppBodyStart")
          }}<a
            href="https://git.rwth-aachen.de/coscine/docs/public/terms/-/blob/master/PrivacyPolicy.md"
            >Link</a
          >{{ $t("ppBodyEnd") }}
        </p>
        <b-form-checkbox id="checkboxPP" v-model="checkedPP">{{
          $t("ppBodyCheckBox")
        }}</b-form-checkbox>
        <button
          class="btn btn-primary w-100"
          name="tosppContinue"
          @click.prevent="accept()"
          :disabled="!checkedTOS || !checkedPP"
        >
          {{ $t("tosppContinue") }}
        </button>
        <button
          class="btn btn-secondary w-100"
          name="tosppCancel"
          @click.prevent="cancel()"
        >
          {{ $t("tosppCancel") }}
        </button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { TOSApi } from "@coscine/api-connection";

export default Vue.extend({
  name: "TOSAndPP",
  data() {
    return {
      checkedTOS: false,
      checkedPP: false,
    };
  },
  props: {
    tosReturnUrl: String,
  },
  methods: {
    accept() {
      if (this.checkedTOS && this.checkedPP) {
        TOSApi.acceptCurrentTOSVersion(this.getJWT(), (response: any) => {
          location.href = this.tosReturnUrl;
        });
      }
    },
    cancel() {
      window.location.href = "/coscine/api/Coscine.Api.STS/account/logout";
    },
    getJWT() {
      const urlParams = new URLSearchParams(window.location.search);
      const jwt = urlParams.get("jwt");
      return jwt !== null ? jwt : "";
    },
    removeParam(key: string, sourceURL: string) {
      let rtn = sourceURL.split("?")[0];
      let param = "";
      let paramsArr = [];
      const queryString =
        sourceURL.indexOf("?") !== -1 ? sourceURL.split("?")[1] : "";
      if (queryString !== "") {
        paramsArr = queryString.split("&");
        for (let i = paramsArr.length - 1; i >= 0; i -= 1) {
          param = paramsArr[i].split("=")[0];
          if (param === key) {
            paramsArr.splice(i, 1);
          }
        }
        rtn = rtn + "?" + paramsArr.join("&");
      }
      return rtn;
    },
  },
});
</script>

<style scoped>
.custom-checkbox {
  margin-left: 1em;
  margin-bottom: 0.5em;
  margin-top: -0.7em;
}
</style>
